/*
 * Created on 04.12.2003
 *
 */

/**
 * @author Marc-Oliver Pahl
 *
 * Wozu dient das Beispiel?
 * -------------------------------------------------------------------------
 * Mithilfe des Debuggers knnen die auf den Folien gesehenen Zustnde,
 * die die beiden Versionen der Summe durchlaufen noch einmal schn nach-
 * vollzogen werden.
 * 
 * Dazu msst Ihr IM QUELLCODE UNTEN BREAKPOINTS SETZEN und zwar an den
 * unten markierten Stellen. Einfach links des weien Quellcodebereichs
 * auf den Balken doppelt klicken. Dann erscheint ein blauer Kreis. Das
 * ist ein Breakpoint. Breakpoints neben Kommentarzeilen haben keine Wir-
 * kung!
 * An diesen Stellen hlt der Debugger spter an und wir haben die Mg-
 * lichkeit, die Variablen anzusehen.
 * 
 * Was ist zu tun?
 * -------------------------------------------------------------------------
 * 1.) Breakpoints an den unten markierten Stellen setzen
 * 
 * 2.) starten mit: [Run] -> [Debug As] -> [Java Application]
 * 
 * [F8] die Abarbeitung bis zum Erreichen des nchsten Breakpoints
 *      (oder zum Ende des Programms) fortfhren
 * 
 * [F7] einen Schritt (die aktuelle Zeile) ausfhren und dann wieder stoppen
 * 
 * Was sehen wir? (-> Folien)
 * -------------------------------------------------------------------------
 * Bei der rekursiven Varianten sehen wir, wenn wir mit [F7] durch das Pro-
 * gramm laufen, dass fr jeden rekursiven Aufruf unserer rekursiven Fkt.
 * ein neuer Kontext auf dem Stack erzeugt wird (linkes Fenster mit dem Titel 
 * "Debug"). Es wird also wirklich jedes Mal neuer Speicher ("ein neues Blatt") 
 * verwendet.
 * 
 * Bei der iterativen Variante sehen wir, dass sich die Variablen (rechts "Va-
 * riables") tatschlich wie erwartet verndern.
 */
public class sum {
	/* Die Rekurive Variante unserer Summenfunktion */
	public static int sum_rek(int n){
/* in der NCHSTEN Zeile BREAKPOINT setzen ---------------------------------------- */	
		if ( n == 0 ) return 0;           // Abbruchkriterium fr die Rekursion
		return ( n + sum_rek( n-1 ) );    // rekursiver Aufruf der Fkt.
	}
	
	/* Die iterative Variante unserer Summenfunktion */
	public static int sum_iter(int n){
		int k = n;                        // Vorbereitung
		int erg = 0;
		while ( k >= 0) {                 // Schleifen-Arbeit
/* in der NCHSTEN Zeile BREAKPOINT setzen ---------------------------------------- */
			erg = k + erg;
			k = k - 1;
		}
		return erg;                       // Nachbereitung
	}

	/* Die main-Methode, die beim Start des Programms ausgefhrt wird */
	public static void main(String[] args) {
		System.out.print("rekurive Variante: ");
		System.out.println("sum_rek(3) ergibt "+sum_rek(3)+".");

		System.out.print("iterative Variante: ");
		System.out.println("sum_iter(3) ergibt "+sum_iter(3)+".");
	}
}
